import java.io.*;
import java.util.*;

public class B {

    public void solve() throws IOException {
        long k = nextLong();
        if (k == 0) {
            out.print(0);
            return;
        }
        long cur = 1;
        long ans = Long.MAX_VALUE;
        boolean neg = false;
        if (k < 0) {
            neg = true;
            k *= -1;
        }
        while (cur * cur <= k) {
            if (k % cur == 0) {
                long x = cur;
                long y = k / cur;
                if ((x - y) % 2 == 0) {
                    if (!neg) {
                        ans = Math.min(ans, (x + y) / 2);
                    } else {
                        long l = (x + y) / 2;
                        long r = (y - x) / 2;
                        ans = Math.min(ans, Math.min(l, r));
                    }
                }
            }
            cur++;
        }
        if (ans != Long.MAX_VALUE) {
            out.print(ans);
        } else {
            out.print("none");
        }
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new B().run();
    }

}