import java.io.*;
import java.util.*;

public class ASlow {

    public void slow(int a, int b, int c) {
        int ans = 0;
        int cntX = 0;
        int cntY = 0;
        while (a < b) {
            if ((a + 2) % c != 0) {
                a += 2;
                cntY++;
                ans++;
            } else {
                a += 1;
                ans++;
                cntX++;
            }
        }
        out.print(ans);
       /* out.print(cntX);
        out.print(' ');
        out.println(cntY);
        out.flush();*/
    }

    public void solve() throws IOException {
        int ans = 0;
        int a = nextInt();
        int b = nextInt();
        int c = nextInt();
        if (c == 2 || (a % 2 == 1 && c % 2 == 0)) {
            out.print((b - a + 1) / 2);
        } else {
            slow(a, b, c);
        }
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new ASlow().run();
    }

}