import java.io.*;
import java.util.*;

public class A {
    public void solve() throws IOException {
        long l = nextLong();
        long r = nextLong();
        long a = nextLong();
        if (r - l < a) {
            out.print(0);
            return;
        }
        long ans = 0;
        long first = r - l;
        long add = (((first % a) - (a - 1)) + a) % a;
        first -= add;
        long from = (first / a);
        ans += a * (from * (from + 1) / 2);
        ans += add * (from + 1);
        out.print(ans);
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new A().run();
    }

}