import java.io.*;
import java.util.*;

public class B {

    public boolean check(long x) {
        long tmp = (long) Math.sqrt(x);
        return tmp * tmp == x;
    }

    public void solve() throws IOException {
        long k = nextLong();
        for (int i = 0; i < 1e7; i++) {
            if (k >= 0 && check(k)) {
                out.print((long)Math.sqrt(k));
                return;
            }
            k += 2 * (i + 1) - 1;
        }
        out.print("none");
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new B().run();
    }

}