import java.io.*;
import java.util.*;

public class C {
    public void solve() throws IOException {
        int m = nextInt();
        int n = nextInt();
        List<Integer> a = new ArrayList<Integer>(n);
        for (int i = 0; i < n; i++) {
            a.add(nextInt());
        }
        List<Integer> b = new ArrayList<Integer>(m);
        for (int i = 0; i < m; i++) {
            b.add(nextInt());
        }
        int start = 0;
        List<Integer> ans = new ArrayList<Integer>((int) 3e5);
        while (start < a.size()) {
            int cur = b.get(0);
            int ind = a.indexOf(cur);

            int maxPos = -1;
            for (int i = 0; i < ind; i++) {
                maxPos = Math.max(maxPos, b.indexOf(a.get(i)));
            }
            if (maxPos == -1) {
                if (a.size() < 2 || a.get(ind + 1) != cur) {
                    maxPos = b.size() - 1;
                } else {
                    maxPos = 0;
                }
            }
            ans.add(maxPos + 1);
            b.add(maxPos + 1, cur);
            b.remove(0);
            if (ind == 0) {
                a.remove(0);
            }
        }
        out.println(ans.size());
        for (int i = 0; i < ans.size(); i++) {
            out.print(ans.get(i));
            out.print(' ');
        }
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new C().run();
    }

}