import java.io.*;
import java.util.*;

public class ASlow {

    public int slow(int a, int b, int c) {
        int ans = 0;
        int cntX = 0;
        int cntY = 0;
        while (a < b) {
            if ((a + 2) % c != 0) {
                a += 2;
                cntY++;
                ans++;
            } else {
                a += 1;
                ans++;
                cntX++;
            }
        }
        return ans;
    }

    public int getCnt(int l, int r, int c) {
        int newL = l + ((c - l % c)) % c;
        int newR = r - r % c;
        if (newR < newL)
            return 0;
        int ans = (newR - newL) / c;
        return ans + 1;
    }

    public int fast(int a, int b, int c) {
        if (c == 2 || (a % 2 == 1 && c % 2 == 0)) {
            return (b - a + 1) / 2;
        } else {
            int x;
            if (c % 2 == 0) {
                x = getCnt(a, b, c);
                if (x > 0) {
                    x = 1;
                }
            } else {
                x = getCnt(a, b, c);
                if (x == 0) {
                    return (b - a + 1) / 2;
                }
                int first = a + ((c - a % c)) % c;
                if (first % 2 != a % 2) {
                    x--;
                }
            }
            int y = (b - a - x + 1) / 2;
            return x + y;
        }
    }

    public void solve() throws IOException {
        out.print(fast(nextInt(), nextInt(), nextInt()));
    }

    public void run() {
        try {
            br = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        new ASlow().run();
    }

}